<script setup lang="ts">
import { computed, onMounted, ref } from 'vue'
import axios from 'axios'

const currentDateTime = ref('')
const VDate = ref<Date | null>(null)

const handleDateChange = (newDate: Date) => {
  VDate.value = newDate
}

const history = ref<{ type: string; time: string }[]>([])

const reversedHistory = computed(() => {
  return history.value.slice().reverse()
})

const formatDate = (date: Date) => {
  const day = String(date.getDate()).padStart(2, '0')
  const month = String(date.getMonth() + 1).padStart(2, '0')
  const year = date.getFullYear()
  return `${day}/${month}/${year}`
}
const formatDateX = (date: Date) => {
  const day = String(date.getDate()).padStart(2, '0')
  const month = String(date.getMonth() + 1).padStart(2, '0')
  const year = date.getFullYear()
  return `${month}/${day}/${year}`
}

const formatTime = (date: Date) => {
  const hours = String(date.getHours()).padStart(2, '0')
  const minutes = String(date.getMinutes()).padStart(2, '0')
  return `${hours}:${minutes}`
}

const updateDateTime = () => {
  const date = new Date()
  currentDateTime.value = `${formatTime(date)}   ${formatDate(date)}`
}

const fetchHistoryData = async () => {
  try {
    const response = await api.get('/history')
    history.value = response.data
  } catch (error) {
    console.error('Error fetching history data:', error)
  }
}

onMounted(() => {
  fetchHistoryData()
  setInterval(updateDateTime, 1000)
})

const handleClockOut = async () => {
  try {
    await axios.post('http://localhost:3000/clock-out')
    const response = await api.get('/history') // Fetch updated history from backend
    history.value = response.data
    console.log('New Clock Out Item:', history.value[history.value.length - 1])
  } catch (error) {
    console.error('Error during Clock Out:', error)
  }
}

const handleClockIn = async () => {
  try {
    await api.post('/clock-in')
    const response = await api.get('/history') // Fetch updated history from backend
    history.value = response.data
    console.log('New Clock In Item:', history.value[history.value.length - 1])
  } catch (error) {
    console.error('Error during Clock In:', error)
  }
}

import { onBeforeUnmount, onBeforeMount } from 'vue'
import api from '@/service/http'
const saveTimeline = () => {
  localStorage.setItem('timeline', JSON.stringify(history.value))
}

const loadTimeline = () => {
  const savedTimeline = localStorage.getItem('timeline')

  if (savedTimeline) {
    history.value = JSON.parse(savedTimeline)
  }
}

onBeforeMount(() => {
  loadTimeline()
})

onBeforeUnmount(() => {
  saveTimeline()
})

const filteredItems = computed(() => {
  let selectedDate: string | null = null

  if (VDate.value) {
    selectedDate = formatDate(VDate.value)
  } else {
    selectedDate = formatDate(new Date())
  }

  console.log('Selected Date:', selectedDate) // แสดงค่าของ selectedDate
  return reversedHistory.value.filter((item) => {
    const formattedDate = formatDate(new Date())
    console.log('Formatted Date:', formattedDate) // แสดงค่า formattedDate ที่ถูกแปลง
    const result = formattedDate === selectedDate

    // แสดงผลลัพธ์ของการเปรียบเทียบ
    if (result) {
      console.log(`Formatted Date (${formattedDate}) is EQUAL to Selected Date (${selectedDate})`)
    } else {
      console.log(
        `Formatted Date (${formattedDate}) is NOT EQUAL to Selected Date (${selectedDate})`
      )
    }

    return result
  })
})

const clearTimeline = async () => {
  try {
    await axios.delete('http://localhost:3000/history/clear') // แก้ URL ตามที่ NestJS รัน
    history.value = []
    saveTimeline() // Save the cleared timeline to Local Storage
  } catch (error) {
    console.error('Error clearing history:', error)
  }
}
</script>

<template>
  <div style="width: 95%; height: 100%">
    <v-container>
      <v-row justify="space-around" style="margin-top: 25; border: 2px solid #bbdefb">
        <v-col cols="auto" style="padding-top: 10%">
          <v-dialog transition="dialog-bottom-transition" width="auto">
            <template v-slot:activator="{ props }">
              <v-btn color="green" v-bind="props" @click="handleClockIn">Clock In</v-btn>
            </template>
            <template v-slot:default="{ isActive }">
              <v-card>
                <v-toolbar color="green" title="Check In"></v-toolbar>
                <v-card-text>
                  <div class="text-h2 pa-12">Clock In Complete!</div>
                </v-card-text>
                <v-card-actions class="justify-end">
                  <v-btn variant="text" @click="isActive.value = false">Close</v-btn>
                </v-card-actions>
              </v-card>
            </template>
          </v-dialog>
        </v-col>

        <v-col cols="auto">
          <h1>{{ currentDateTime }}</h1>
        </v-col>

        <v-col cols="auto" style="padding-top: 10%">
          <v-dialog transition="dialog-top-transition" width="auto">
            <template v-slot:activator="{ props }">
              <v-btn color="red" v-bind="props" @click="handleClockOut">Clock Out</v-btn>
            </template>
            <template v-slot:default="{ isActive }">
              <v-card>
                <v-toolbar color="red" title="Check Out"></v-toolbar>
                <v-card-text>
                  <div class="text-h2 pa-12">Clock Out Complete!</div>
                </v-card-text>
                <v-card-actions class="justify-end">
                  <v-btn variant="text" @click="isActive.value = false">Close</v-btn>
                </v-card-actions>
              </v-card>
            </template>
          </v-dialog>
        </v-col>
      </v-row>

      <v-row style="background-color: #bbdefb; border-radius: 5%; margin-top: 3%">
        <v-col>
          <v-timeline side="end" align="start">
            <v-timeline-item
              v-for="item in filteredItems"
              :key="item.time"
              :dot-color="item.type === 'in' ? 'teal-lighten-3' : 'pink'"
              size="small"
            >
              <div class="d-flex">
                <strong class="me-4"
                  >{{ formatTime(new Date(item.time)) }}
                  {{ formatDateX(new Date(item.time)) }}</strong
                >

                <div>
                  <strong>{{ item.type === 'in' ? 'Check In' : 'Check Out' }}</strong>
                  <div class="text-caption mb-2">Poomrapee Sadsamai</div>
                </div>
              </div>
            </v-timeline-item>
          </v-timeline></v-col
        >
        <v-col>
          <div>{{ VDate ? formatDate(VDate) : formatDate(new Date()) }}</div>
        </v-col>

        <v-col
          ><v-date-picker
            v-model="VDate"
            @input="handleDateChange"
            style="background-color: #bbdefb"
          >
          </v-date-picker>
          <v-btn
            icon="mdi-refresh"
            size="x-small"
            @click="clearTimeline"
            style="background-color: red"
          ></v-btn>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>
